From e2e303f7f2bbef6366c4b55431ea5ae1f7641d4e Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: May 11 2020 05:57:32 +0000
Subject: [PATCH 596/2232] Infer enum repr based on discriminant range


---

diff --git a/syntax/discriminant.rs b/syntax/discriminant.rs
index e14c6a0..388a117 100644
--- a/syntax/discriminant.rs
+++ b/syntax/discriminant.rs
@@ -1,18 +1,19 @@
 use crate::syntax::Atom::{self, *};
 use proc_macro2::{Literal, Span, TokenStream};
 use quote::ToTokens;
-use std::collections::HashSet;
+use std::cmp::Ordering;
+use std::collections::BTreeSet;
 use std::fmt::{self, Display};
 use std::str::FromStr;
 use syn::{Error, Expr, Lit, Result, Token, UnOp};
 
 pub struct DiscriminantSet {
     repr: Option<Atom>,
-    values: HashSet<Discriminant>,
+    values: BTreeSet<Discriminant>,
     previous: Option<Discriminant>,
 }
 
-#[derive(Copy, Clone, Hash, Eq, PartialEq)]
+#[derive(Copy, Clone, Eq, PartialEq)]
 pub struct Discriminant {
     negative: bool,
     magnitude: u32,
@@ -22,7 +23,7 @@ impl DiscriminantSet {
     pub fn new() -> Self {
         DiscriminantSet {
             repr: None,
-            values: HashSet::new(),
+            values: BTreeSet::new(),
             previous: None,
         }
     }
@@ -54,6 +55,24 @@ impl DiscriminantSet {
         };
         insert(self, discriminant)
     }
+
+    pub fn inferred_repr(&self) -> Result<Atom> {
+        if let Some(repr) = self.repr {
+            return Ok(repr);
+        }
+        if self.values.is_empty() {
+            return Ok(U8);
+        }
+        let min = *self.values.iter().next().unwrap();
+        let max = *self.values.iter().next_back().unwrap();
+        for bounds in &BOUNDS {
+            if bounds.min <= min && max <= bounds.max {
+                return Ok(bounds.repr);
+            }
+        }
+        let msg = "these discriminant values do not fit in any supported enum repr type";
+        Err(Error::new(Span::call_site(), msg))
+    }
 }
 
 fn expr_to_discriminant(expr: &Expr) -> Result<(Discriminant, Option<Atom>)> {
@@ -157,6 +176,23 @@ impl FromStr for Discriminant {
     }
 }
 
+impl Ord for Discriminant {
+    fn cmp(&self, other: &Self) -> Ordering {
+        match (self.negative, other.negative) {
+            (true, true) => self.magnitude.cmp(&other.magnitude).reverse(),
+            (true, false) => Ordering::Less, // negative < positive
+            (false, true) => Ordering::Greater, // positive > negative
+            (false, false) => self.magnitude.cmp(&other.magnitude),
+        }
+    }
+}
+
+impl PartialOrd for Discriminant {
+    fn partial_cmp(&self, other: &Self) -> Option<Ordering> {
+        Some(self.cmp(other))
+    }
+}
+
 fn parse_int_suffix(suffix: &str) -> Result<Option<Atom>> {
     if suffix.is_empty() {
         return Ok(None);
diff --git a/syntax/mod.rs b/syntax/mod.rs
index e1402a0..4702a69 100644
--- a/syntax/mod.rs
+++ b/syntax/mod.rs
@@ -63,6 +63,7 @@ pub struct Enum {
     pub ident: Ident,
     pub brace_token: Brace,
     pub variants: Vec<Variant>,
+    pub repr: Atom,
 }
 
 pub struct ExternFn {
diff --git a/syntax/parse.rs b/syntax/parse.rs
index 3ca63ab..1525fbc 100644
--- a/syntax/parse.rs
+++ b/syntax/parse.rs
@@ -6,7 +6,7 @@ use crate::syntax::{
     Struct, Ty1, Type, TypeAlias, Var, Variant,
 };
 use proc_macro2::TokenStream;
-use quote::{format_ident, quote};
+use quote::{format_ident, quote, quote_spanned};
 use syn::parse::{ParseStream, Parser};
 use syn::punctuated::Punctuated;
 use syn::{
@@ -134,12 +134,24 @@ fn parse_enum(cx: &mut Errors, item: ItemEnum) -> Result<Api> {
         });
     }
 
+    let enum_token = item.enum_token;
+    let brace_token = item.brace_token;
+
+    let repr = match discriminants.inferred_repr() {
+        Ok(repr) => repr,
+        Err(err) => {
+            let span = quote_spanned!(brace_token.span=> #enum_token {});
+            return Err(Error::new_spanned(span, err));
+        }
+    };
+
     Ok(Api::Enum(Enum {
         doc,
-        enum_token: item.enum_token,
+        enum_token,
         ident: item.ident,
-        brace_token: item.brace_token,
+        brace_token,
         variants,
+        repr,
     }))
 }
 

